//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_width1 1
#property indicator_width2 1

extern double UpperPercent     = 10;
extern double LowerPercent     = 10;
extern bool   DisregardHighLow = true;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsPushNotif  = false;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

double up[];
double dn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   SetIndexBuffer(0,up); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,dn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   return (0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
         //
         //
         //
         //
         //

   for (int i=limit; i>=0; i--)   
   {
      double upperWick  = High[i]-MathMax(Open[i],Close[i]);
      double lowerWick  = MathMin(Open[i],Close[i])-Low[i];
      double candleSize = MathMax(High[i]-Low[i],Point);
         up[i] = EMPTY_VALUE;
         dn[i] = EMPTY_VALUE;
         if (DisregardHighLow)
         {
            if ((upperWick/candleSize)>=(UpperPercent/100.0)) up[i] = High[i];
            if ((lowerWick/candleSize)>=(LowerPercent/100.0)) dn[i] = Low[i];
         }
         else
         {
            if ((upperWick/candleSize)>=(UpperPercent/100.0) && High[i]>High[i+1]) up[i] = High[i];
            if ((lowerWick/candleSize)>=(LowerPercent/100.0) && Low[i] <Low[i+1] ) dn[i] = Low[i];
         }            
   }
   Comment(upperWick/candleSize);
   manageAlerts();
   return (0);   
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      static datetime lastTime1 = 0;
      static string   lastMess1 = "";
         if (up[whichBar] != EMPTY_VALUE) doAlert(lastMess1,lastTime1,"up");
      static datetime lastTime2 = 0;
      static string   lastMess2 = "";
         if (dn[whichBar] != EMPTY_VALUE) doAlert(lastMess2,lastTime2,"down");
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," percent wick alert ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol(),"percent wick"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol(),"percent wick"+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

